
/*


*/

struct m68k_memory_interface
{
	int		opcode_xor;						// Address Calculation
	unsigned char		(*read8)(int);				// Normal read 8 bit
	unsigned short int	(*read16)(int);				// Normal read 16 bit
	unsigned long int	(*read32)(int);				// Normal read 32 bit
	void		(*write8)(int, unsigned char);		// Write 8 bit
	void		(*write16)(int, unsigned short int);	// Write 16 bit
	void		(*write32)(int, unsigned long int);	// Write 32 bit
	void		(*changepc)(int);			// Change PC routine

    // For Encrypted Stuff

	unsigned char		(*read8pc)(int);				// PC Relative read 8 bit
	unsigned short int	(*read16pc)(int);			// PC Relative read 16 bit
	unsigned long int	(*read32pc)(int);			// PC Relative read 32 bit

	unsigned short int	(*read16d)(int);				// Direct read 16 bit
	unsigned long int	(*read32d)(int);				// Direct read 32 bit
};

struct A68KContext
{
  unsigned int d[8],a[8];
  unsigned int isp,srh,ccr,xc,pc,irq,sr;
  int (*IrqCallback) (int nIrq);
  unsigned int ppc;
  void *pResetCallback;
  unsigned int sfc,dfc,usp,vbr;
  unsigned int nAsmBank,nCpuVersion;
};

extern "C" struct A68KContext M68000_regs;

extern "C" struct m68k_memory_interface a68k_memory_intf;
extern "C" unsigned char *OP_ROM,*OP_RAM;
extern "C" int m68k_ICount;
extern "C" unsigned int mem_amask;
extern "C" unsigned int mame_debug,cur_mrhard,m68k_illegal_opcode,illegal_op,illegal_pc,opcode_entry;

extern "C" void M68000_RUN(void);
extern "C" void M68000_RESET(void);
