
/*

  header for CPS2 machine

*/


#ifndef CPS2CPUCORE_H
#define CPS2CPUCORE_H

#include "cpucore.h"
#include "ym2151/ym2151.h"
#include "okim6295/adpcm.h"

class cps2cpucore: public cpucore
{
private:

	int kludge;

	char romname[64];
	unsigned long int protport,protval;
	int charbase,tile16base,tile32base;
	int charpad,tile16pad,tile32pad;
	int layercontrol;
	int cps1_lso;
	int layer_enabled[4];

	int sndbufsize;
	OKIM6295interface okim;
	int snddivider;
	short int* psndbuf[2];

	// memory regions

	signed char* qsoundrom;

	signed short int* soundbuf[2];
	short int* tempsoundbuf;
	short int* realsoundbuf;

	// z80
	
	CONTEXTMZ80 ctx1;

public:

	cps2cpucore(tRomSpace* roms);
	~cps2cpucore();

	int a68kReset();
	void cps2decrypt();
	void emulate(int snd);
	void build_palette(tCharset* chset);
	void update_controls();
	void drawScroll1(unsigned long int* video,tCharset* chset);
	void drawScroll2(unsigned long int* video,tCharset* chset);
	void drawScroll2rs(unsigned long int* video,tCharset* chset);
	void drawScroll3(unsigned long int* video,tCharset* chset);
	void cps2calc_lso();
	void drawSprites(unsigned long int* video,tCharset* chset,int minpri,int maxpri);
	void draw_layer(int l,unsigned long int* video,tCharset* chset);
	void checkquickstate();
	void drawScreen(unsigned long int* video,tCharset* chset);
};

#endif