
/*

  sound functions
  (windows)

*/

#include "sound.h"

extern tGui* gui;
static MIDASstreamHandle   m_hStream;
static const int mbl=100;

int initSound(HWND hwn,int rate)
{
    BOOL    bResult;

    bResult = MIDASstartup();
    if (bResult == FALSE)
	{
		return 1;
	}
 
    MIDASsetOption(MIDAS_OPTION_DSOUND_HWND,    (DWORD)hwn);
    MIDASsetOption(MIDAS_OPTION_OUTPUTMODE,     MIDAS_MODE_16BIT_STEREO);
    MIDASsetOption(MIDAS_OPTION_MIXRATE,        rate);
    MIDASsetOption(MIDAS_OPTION_MIXBUFLEN,      mbl);
    MIDASsetOption(MIDAS_OPTION_MIXBUFBLOCKS,   MIDASgetOption(MIDAS_OPTION_MIXBUFBLOCKS));

	if (!gui->guiinfo.interpolate)
	{
		MIDASsetOption(MIDAS_OPTION_FILTER_MODE,    MIDAS_FILTER_NONE );
	    MIDASsetOption(MIDAS_OPTION_MIXING_MODE,    MIDAS_MIX_NORMAL_QUALITY);
	}
	else
	{
		MIDASsetOption(MIDAS_OPTION_FILTER_MODE,    MIDAS_FILTER_MORE );
	    MIDASsetOption(MIDAS_OPTION_MIXING_MODE,    MIDAS_MIX_HIGH_QUALITY);
	}

	if (gui->guiinfo.usedsound)
	{
	    MIDASsetOption(MIDAS_OPTION_DSOUND_MODE,    MIDAS_DSOUND_STREAM);
	    MIDASsetOption(MIDAS_OPTION_DSOUND_BUFLEN,  MIDASgetOption(MIDAS_OPTION_DSOUND_BUFLEN));
	}
	else
	{
		MIDASsetOption(MIDAS_OPTION_DSOUND_MODE,    MIDAS_DSOUND_DISABLED);
	}
 

    bResult = MIDASinit();
    if (bResult == FALSE)
	{
		return 1;
	}

    bResult = MIDASstartBackgroundPlay(4 * 60);
    if (bResult == FALSE)
	{
		return 1;
	}

    bResult = MIDASopenChannels(1);
    if (bResult == FALSE)
	{
		return 1;
	}

    MIDASsetAmplification(100);

	//
	// now init audio stream
	//

    unsigned int nBufLength;
    nBufLength=mbl;
    m_hStream=MIDASplayStreamPolling(MIDAS_SAMPLE_16BIT_STEREO,rate,nBufLength);
    if (m_hStream==0)
    {
        return 1;
    }

	return 0;
}  
  
// 
// stomping sound    
// 
 
void shutdownSound()
{   
    if (m_hStream != NULL) MIDASstopStream(m_hStream);
    m_hStream = NULL;

    MIDAScloseChannels();
    MIDASstopBackgroundPlay();
    MIDASclose();
}

//

void feedBuffer(short int* buf,int buflen)
{
    MIDASfeedStreamData(m_hStream,
                        (unsigned char*)buf,
                        buflen*2,
                        FALSE);
}
